package com.trs.ggzyexchange.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.service.GcBidpublicityService;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.QtjyNoticeService;
import com.trs.ggzyexchange.service.TenderDetailsVoService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 其他交易公告信息 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-03-03
 */
@RestController
@RequestMapping("/qtjy-notice")
public class QtjyNoticeController extends BaseController {

    @Autowired
    private QtjyNoticeService qtjyNoticeService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;


    //GetMapping(value = "/queryPageListAll")
    public Result<IPage<TenderDetailsVo>> queryPageListAll(
            @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
            @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
            HttpServletRequest req
    ){
        Page<QtjyNotice> page = new Page<QtjyNotice>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = qtjyNoticeService.queryQtjyNoticeAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.OTHER_TRANSACTION_ANNOUNCEMENT.getCode());
            record.setNoticeTypeName(ClassIfy.OTHER_TRANSACTION_ANNOUNCEMENT.getName());
            record.setTransactionTypeCode(ClassIfy.OTHER_TRANSACTIONS_ANNOUNCEMENT.getCode());
            record.setTransactionTypeName(ClassIfy.OTHER_TRANSACTIONS_ANNOUNCEMENT.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllQtjyNoticeOrther(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return Result.OK(tenderDetailsVoIPage);
    }

    //@GetMapping(value = "/queryPageListUpdateEs")
    public Integer queryPageListUpdateEs() throws JsonProcessingException {
        int count = qtjyNoticeService.count();
        Integer pageNo = 1;
        Integer pageSize = 1000;
        Integer pageNum = (int)Math.ceil((double)count/pageSize);
        List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
        for(int i = 1; i <= pageNum;i++){
            List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize);
            Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
        }
        return tenderDetailsVos.size();
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize){
        Page<QtjyNotice> page = new Page<QtjyNotice>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = qtjyNoticeService.queryQtjyNoticeAllList(page);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setNoticeTypeCode(ClassIfy.OTHER_TRANSACTION_ANNOUNCEMENT.getCode());
            record.setNoticeTypeName(ClassIfy.OTHER_TRANSACTION_ANNOUNCEMENT.getName());
            record.setTransactionTypeCode(ClassIfy.OTHER_TRANSACTIONS_ANNOUNCEMENT.getCode());
            record.setTransactionTypeName(ClassIfy.OTHER_TRANSACTIONS_ANNOUNCEMENT.getName());
            record = tenderDetailsVoService.getTenderDetailsVoAllQtjyNoticeOrther(record);
            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }
}
